## TpCallStreamEndpoint

TpCallStreamEndpoint — class for TpSvcCallStreamEndpoint implementations

## Functions

TpCallStreamEndpoint * | tp_call_stream_endpoint_new ()
const gchar * | tp_call_stream_endpoint_get_object_path ()
TpStreamEndpointState | tp_call_stream_endpoint_get_state ()
void | tp_call_stream_endpoint_add_new_candidates ()
void | tp_call_stream_endpoint_add_new_candidate ()
void | tp_call_stream_endpoint_set_remote_credentials ()

## Properties

gboolean | controlling | Read
TpDBusDaemon * | dbus-daemon | Read / Write / Construct Only
GHashTable_guint+guint_* | endpoint-state | Read
gboolean | is-ice-lite | Read / Write / Construct Only
gchar * | object-path | Read / Write / Construct Only
GPtrArray_GValueArray_guint+gchararray+guint+GHashTable_gchararray+GValue___* | remote-candidates | Read
GValueArray_gchararray+gchararray_* | remote-credentials | Read
GPtrArray_GValueArray_GValueArray_guint+gchararray+guint+GHashTable_gchararray+GValue__+GValueArray_guint+gchararray+guint+GHashTable_gchararray+GValue____* | selected-candidate-pairs | Read
guint | transport | Read / Write / Construct Only

## Signals

void | candidate-accepted | Run Last
void | candidate-rejected | Run Last
void | candidate-selected | Run Last

## Types and Values

struct | TpCallStreamEndpoint
struct | TpCallStreamEndpointClass

## Object Hierarchy

        GObject
        ╰── TpCallStreamEndpoint

## Implemented Interfaces

TpCallStreamEndpoint implements TpSvcCallStreamEndpoint and TpSvcDBusProperties.

## Includes

    #include <telepathy-glib/telepathy-glib.h>

## Description

This class makes it easier to write TpSvcCallStreamEndpoint implementations by implementing its properties and methods.

## Functions

### tp_call_stream_endpoint_new ()

    TpCallStreamEndpoint *
    tp_call_stream_endpoint_new (TpDBusDaemon *dbus_daemon,
                                 const gchar *object_path,
                                 TpStreamTransportType transport,
                                 gboolean is_ice_lite);

Create a new TpCallStreamEndpoint object. It is registered on the bus at construction, and is unregistered at dispose.

#### Parameters

dbus_daemon | value of “dbus-daemon” property |
object_path | value of “object-path” property |
transport | value of “transport” property |
is_ice_lite | value of “is_ice_lite” property |

#### Returns

a new TpCallStreamEndpoint.

Since 0.17.5

### tp_call_stream_endpoint_get_object_path ()

    const gchar *
    tp_call_stream_endpoint_get_object_path
                                   (TpCallStreamEndpoint *self);

#### Parameters

self | a TpCallStreamEndpoint |

#### Returns

the value of “object-path”

Since 0.17.5

### tp_call_stream_endpoint_get_state ()

    TpStreamEndpointState
    tp_call_stream_endpoint_get_state (TpCallStreamEndpoint *self,
                                       TpStreamComponent component);

#### Parameters

self | a TpCallStreamEndpoint |
component | a TpStreamComponent |

#### Returns

the state of `self` 's `component`

Since 0.17.5

### tp_call_stream_endpoint_add_new_candidates ()

    void
    tp_call_stream_endpoint_add_new_candidates
                                   (TpCallStreamEndpoint *self,
                                    const GPtrArray *candidates);

Add `candidates` to the “remote-candidates” property. See Also: `tp_call_stream_endpoint_add_new_candidate()`.

#### Parameters

self | a TpCallStreamEndpoint |
candidates | GPtrArray of GValueArray defining the candidates to add |

Since 0.17.5

### tp_call_stream_endpoint_add_new_candidate ()

    void
    tp_call_stream_endpoint_add_new_candidate
                                   (TpCallStreamEndpoint *self,
                                    TpStreamComponent component,
                                    const gchar *address,
                                    guint port,
                                    const GHashTable *info_hash);

Add a candidate to the “remote-candidates” property. See Also: `tp_call_stream_endpoint_add_new_candidates()`.

#### Parameters

self | a TpCallStreamEndpoint |
component | a TpStreamComponent |
address | an IP address |
port | a port number |
info_hash | string -> GValue mapping for extra info |

Since 0.17.5

### tp_call_stream_endpoint_set_remote_credentials ()

    void
    tp_call_stream_endpoint_set_remote_credentials
                                   (TpCallStreamEndpoint *self,
                                    const gchar *username,
                                    const gchar *password);

Set the username and password to use for `self` 's crendentials.

#### Parameters

self | a TpCallStreamEndpoint |
username | the username |
password | the password |

Since 0.17.5

## Types and Values

### struct TpCallStreamEndpoint

    struct TpCallStreamEndpoint;

A class for call stream endpoint implementations

Since 0.17.5

### struct TpCallStreamEndpointClass

    struct TpCallStreamEndpointClass {
    };

The class structure for TpCallStreamEndpoint

Since 0.17.5

## Property Details

### The `“controlling”` property

      “controlling”              gboolean

Whether or not the local side is taking the controlling role.

Flags: Read

Default value: FALSE

Since 0.17.5

### The `“dbus-daemon”` property

      “dbus-daemon”              TpDBusDaemon *

The connection to the DBus daemon owning the CM.

Flags: Read / Write / Construct Only

Since 0.17.5

### The `“endpoint-state”` property

      “endpoint-state”           GHashTable_guint+guint_*

GHashTable{TpStreamComponent -> TpStreamEndpointState} The state of this endpoint.

Flags: Read

Since 0.17.5

### The `“is-ice-lite”` property

      “is-ice-lite”              gboolean

Whether or not the Remote side is an ICE Lite endpoint.

Flags: Read / Write / Construct Only

Default value: FALSE

Since 0.17.5

### The `“object-path”` property

      “object-path”              gchar *

The D-Bus object path used for this object on the bus.

Flags: Read / Write / Construct Only

Default value: NULL

Since 0.17.5

### The `“remote-candidates”` property

      “remote-candidates”        GPtrArray_GValueArray_guint+gchararray+guint+GHashTable_gchararray+GValue___*

GPtrArray{candidate GValueArray} The remote candidates of this endpoint.

Flags: Read

Since 0.17.5

### The `“remote-credentials”` property

      “remote-credentials”       GValueArray_gchararray+gchararray_*

GValueArray{username string, password string} The remote credentials of this endpoint.

Flags: Read

Since 0.17.5

### The `“selected-candidate-pairs”` property

      “selected-candidate-pairs” GPtrArray_GValueArray_GValueArray_guint+gchararray+guint+GHashTable_gchararray+GValue__+GValueArray_guint+gchararray+guint+GHashTable_gchararray+GValue____*

GPtrArray{local-candidate GValueArray, remote-candidate GValueArray} The candidate pairs selected for this endpoint.

Flags: Read

Since 0.17.5

### The `“transport”` property

      “transport”                guint

The TpStreamTransportType for the content of this endpoint.

Flags: Read / Write / Construct Only

Default value: 0

Since 0.17.5

## Signal Details

### The `“candidate-accepted”` signal

    void
    user_function (TpCallStreamEndpoint *self,
                   gpointer              user_data)

The ::candidate-accepted signal is emitted whenever AcceptSelectedCandidatePair DBus method has been called on this object.

#### Parameters

self | the TpCallStreamEndpoint |
local_candidate | the local candidate |
remote_candidate | the remote candidate |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 0.17.5

### The `“candidate-rejected”` signal

    void
    user_function (TpCallStreamEndpoint *self,
                   gpointer              user_data)

The ::candidate-rejected signal is emitted whenever RejectSelectedCandidatePair DBus method has been called on this object.

#### Parameters

self | the TpCallStreamEndpoint |
local_candidate | the local candidate |
remote_candidate | the remote candidate |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 0.17.5

### The `“candidate-selected”` signal

    void
    user_function (TpCallStreamEndpoint *self,
                   gpointer              user_data)

The ::candidate-selected signal is emitted whenever SetSelectedCandidatePair DBus method has been called on this object.

#### Parameters

self | the TpCallStreamEndpoint |
local_candidate | the local candidate |
remote_candidate | the remote candidate |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since 0.17.5

## See Also

TpBaseMediaCallStream